/*
 * gpio_init.c
 *
 *  Created on: 5 maj 2016
 *      Author: Mateusz
 */

#include "stm32f30x.h"
#include "../src/GPIO_Init/gpio_init.h"



void gpio_init(void){
	GPIO_InitTypeDef gpio;


	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_GPIOA | RCC_AHBPeriph_GPIOB | RCC_AHBPeriph_GPIOC | RCC_AHBPeriph_GPIOD, ENABLE);



	GPIO_StructInit(&gpio);



	//********************USART  ***********************
	//USART Rx
	gpio.GPIO_Pin = GPIO_Pin_15;
	gpio.GPIO_Mode = GPIO_Mode_AF;
	gpio.GPIO_Speed = GPIO_Speed_50MHz;
	gpio.GPIO_OType = GPIO_OType_PP;
	gpio.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOA, &gpio);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource15, GPIO_AF_7);

	//USART Tx
	gpio.GPIO_Pin = GPIO_Pin_2;
	gpio.GPIO_Mode = GPIO_Mode_AF;
	gpio.GPIO_Speed = GPIO_Speed_50MHz;
	gpio.GPIO_OType = GPIO_OType_PP;
	gpio.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOA, &gpio);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_7);

	//*****************GPIO**********************
	//LED_NUCLEO
	gpio.GPIO_Pin = GPIO_Pin_3;
	gpio.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_Init(GPIOB, &gpio);

}

void nvic_init(void){
	NVIC_InitTypeDef nvic;
	//EXTI_InitTypeDef exti;


#ifdef VECT_TAB_RAM
	NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);
#else
	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
#endif


	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);


	//USART_ITConfig(USART2, USART_IT_RXNE, ENABLE);

	nvic.NVIC_IRQChannel = USART2_IRQn;
	nvic.NVIC_IRQChannelPreemptionPriority = 0;
	nvic.NVIC_IRQChannelSubPriority = 0;
	nvic.NVIC_IRQChannelCmd = ENABLE;


	NVIC_Init(&nvic);


}
