/*
 * usart_cmd.c

 *
 *  Created on: 5 maj 2016
 *      Author: Mateusz
 */



#include "usart_stm32.h"



#include <stdlib.h>
#include <string.h>
#include <stdbool.h>



char buforRx[bufLength] = {0};
char bufRxIndex = 0;

char buforTx[bufLength] = {0};
char bufTxIndex = 0;
bool odebranoDane = false;



void usart_init ( USART_TypeDef* USARTx, uint32_t BAUDRATE){

	/* COPY - PASTE to GPIO configuration init for Nucleo STM32F303K8T6
	//-------------- USART  ------------------
	//USART Rx
	gpio.GPIO_Pin = GPIO_Pin_15;
	gpio.GPIO_Mode = GPIO_Mode_AF;
	gpio.GPIO_Speed = GPIO_Speed_50MHz;
	gpio.GPIO_OType = GPIO_OType_PP;
	gpio.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init(GPIOA, &gpio);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource15, GPIO_AF_7);
	//USART Tx
	gpio.GPIO_Pin = GPIO_Pin_2;
	gpio.GPIO_Mode = GPIO_Mode_AF;
	gpio.GPIO_Speed = GPIO_Speed_50MHz;
	gpio.GPIO_OType = GPIO_OType_PP;
	gpio.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init(GPIOA, &gpio);
	GPIO_PinAFConfig(GPIOA, GPIO_PinSource2, GPIO_AF_7);
	//-----------------------------------------
	*/

	USART_InitTypeDef usart;

	if (USARTx == USART1){
		RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, ENABLE);
	} else if (USARTx == USART2){
		RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2, ENABLE);
	}


	USART_StructInit(&usart);

	// ---------- USART CONFIGURATION ------------

	usart.USART_BaudRate = BAUDRATE;


#if USART_WORD_LENGTH == 0
	usart.USART_WordLength = USART_WordLength_8b;
#endif
#if USART_WORD_LENGTH == 1
	usart.USART_WordLength = USART_WordLength_9b;
#endif


#if USART_PARITY == 0
	usart.USART_Parity = USART_Parity_No;
#endif
#if USART_PARITY == 1
	usart.USART_Parity = USART_Parity_Even;
#endif
#if USART_PARITY == 2
	usart.USART_Parity = USART_Parity_Odd;
#endif

#if USART_STOP == 0
	usart.USART_StopBits = USART_StopBits_1;
#endif
#if USART_STOP == 1
	usart.USART_StopBits = USART_StopBits_2;
#endif
#if USART_STOP == 2
	usart.USART_StopBits = USART_StopBits_1_5;
#endif


#if USART_HARDWARE_FLOW_CRTL == 0
	usart.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
#endif
#if USART_HARDWARE_FLOW_CRTL == 1
	usart.USART_HardwareFlowControl = USART_HardwareFlowControl_RTS;
#endif
#if USART_HARDWARE_FLOW_CRTL == 2
	usart.USART_HardwareFlowControl = USART_HardwareFlowControl_CTS;
#endif
#if USART_HARDWARE_FLOW_CRTL == 3
	usart.USART_HardwareFlowControl = USART_HardwareFlowControl_RTS_CTS;
#endif

#if USART_MODE_RX_ENABLE == 1 && USART_MODE_TX_ENABLE == 1
	usart.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
#endif
#if USART_MODE_RX_ENABLE == 1 && USART_MODE_TX_ENABLE == 0
	usart.USART_Mode = USART_Mode_Rx;
#endif
#if USART_MODE_RX_ENABLE == 0 && USART_MODE_TX_ENABLE == 1
	usart.USART_Mode = USART_Mode_Tx;
#endif

	//--------------------------------------------------

	USART_Init(USARTx, &usart);

#if USART_Rx_IT_ENABLE == 1
	USART_ITConfig(USARTx, USART_IT_RXNE, ENABLE);
#endif


	USART_Cmd(USARTx, ENABLE);

}




void usart_putc ( USART_TypeDef* USARTx, char c){
    while (USART_GetFlagStatus(USARTx, USART_FLAG_TXE) == RESET);
    USART_SendData(USARTx, c);
}

void usart_puts ( USART_TypeDef* USARTx, const char *s  ) {
    while ( *s )
    	usart_putc (USARTx, *s++);
}

void usart_putint ( USART_TypeDef* USARTx, int value, int radix ){
	char string [17];

	itoa (value, string, radix);

	usart_puts(USARTx, string);
}

char usart_getc ( USART_TypeDef* USARTx ){
	char c;

	if (USART_GetFlagStatus(USARTx, USART_FLAG_RXNE)){
		c = USART_ReceiveData(USARTx);
	}

	return c;
}


#if USART_Rx_IT_ENABLE == 1

void USART2_IRQHandler (void){
	volatile unsigned long int delay;

	if(USART_GetITStatus(USART2, USART_IT_RXNE) != RESET){
		buforRx[bufRxIndex] = USART_ReceiveData(USART2);
		if(buforRx[bufRxIndex] == 0x0D){
			odebranoDane = true;
			while (bufRxIndex < bufLength){
				buforRx[bufRxIndex] = 0;
				bufRxIndex++;
			}
			bufRxIndex = 0;
		} else {
			if(buforRx[bufRxIndex] != 0x0D){
				bufRxIndex++;
				if(bufRxIndex > bufLength){
					bufRxIndex = 0;
				}
			}
		}
	}
	if(USART_GetITStatus(USART2, USART_IT_TXE) != RESET){
		USART_SendData(USART2, buforTx[bufTxIndex++]);
		for (delay = 0; delay < 150000; delay++);
		if(buforTx[bufTxIndex - 1] == 0x0D){
			USART_ITConfig(USART2, USART_IT_TXE, DISABLE);
			bufTxIndex = 0;
		}
	}
}

#endif
