/*
 * usart_cmd.h
 *
 *  Created on: 5 maj 2016
 *      Author: Mateusz
 */

#ifndef USART_STM32_USART_STM32_H_
#define USART_STM32_USART_STM32_H_

#include "stm32f30x.h"
//#include "stm32f10x.h"

#include <stdbool.h>


#define bufLength	32

extern char buforRx[bufLength];
extern char bufRxIndex;

extern char buforTx[bufLength];
extern char bufTxIndex;
extern bool odebranoDane;


//----------- USART CONFIGURATION ------------

#define USART_Rx_IT_ENABLE 			1			// 0 - DISABLE
												// 1 - ENABLE

#define USART_WORD_LENGTH			0			// 0 - USART_WordLength_8b
												// 1 - USART_WordLength_9b

#define USART_PARITY					0			// 0 - USART_Parity_No
												// 1 - USART_Parity_Even
												// 2 - USART_Parity_Odd

#define USART_STOP					0			// 0 - USART_StopBits_1
												// 1 - USART_StopBits_2
												// 2 - USART_StopBits_1_5

#define USART_HARDWARE_FLOW_CRTL		0			// 0 - USART_HardwareFlowControl_None
												// 1 - USART_HardwareFlowControl_RTS
												// 2 - USART_HardwareFlowControl_CTS
												// 3 - USART_HardwareFlowControl_RTS_CTS

#define USART_MODE_RX_ENABLE			1			// 0 - Rx DISABLE
												// 1 - Rx ENABLE

#define USART_MODE_TX_ENABLE			1			// 0 - Tx DISABLE
												// 1 - Tx ENABLE




// ---------- FUNCTIONS -----------

void usart_init ( USART_TypeDef* USARTx, uint32_t BAUDRATE );


void usart_putc( USART_TypeDef* USARTx, char c );
void usart_puts ( USART_TypeDef* USARTx, const char *s );
void usart_putint ( USART_TypeDef* USARTx, int value, int radix);
char usart_getc ( USART_TypeDef* USARTx );

void USART2_IRQHandler (void);

#endif /* USART_STM32_USART_STM32_H_ */
